/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/

/***********************************************************************
 * PDU Service Classes:
 *	A-ASSOCIATE-AC Class.  
 *
 * Base Classes:
 *
 *	PresentationContextAccept
 *
 *
 *
 *********************************************************************/
		
//##ModelId=38F5FEE80207
class	PresentationContextAccept
	{
	private:
	//##ModelId=38F5FEE9001E
		BYTE							ItemType;	// 0x21
	//##ModelId=38F5FEE803E7
		BYTE							Reserved1;
	//##ModelId=38F5FEE803D3
		UINT16							Length;
	public:
	//##ModelId=38F5FEE803AB
		BYTE							PresentationContextID;
	private:
	//##ModelId=38F5FEE80397
		BYTE							Reserved2;
	public:
	//##ModelId=38F5FEE80383
		BYTE							Result;
	private:
	//##ModelId=38F5FEE80275
		BYTE							Reserved4;
	public:
//		AbstractSyntax				AbsSyntax;
	//##ModelId=38F5FEE8026B
		TransferSyntax				TrnSyntax;
	//##ModelId=38F5FEE90154
					PresentationContextAccept();
	//##ModelId=38F5FEE90168
					PresentationContextAccept(/*AbstractSyntax &, */TransferSyntax &);
	//##ModelId=38F5FEE90140
					~PresentationContextAccept();
//		void		SetAbstractSyntax(AbstractSyntax	&);
	//##ModelId=38F5FEE9010E
		void		SetTransferSyntax(TransferSyntax	&);
	//##ModelId=38F5FEE900DC
		void		SetResult(BYTE	Res) { Result = Res; };
	//##ModelId=38F5FEE900D2
		BYTE		GetResult()	{ return ( Result ); };
	//##ModelId=38F5FEE900A0
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEE90078
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEE90050
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEE9003C
		UINT32	Size();
		
	};

//##ModelId=38F5FEBF033E
class	AAssociateAC
	{
	private:
	//##ModelId=38F5FEC0010F
		BYTE		ItemType;		// 0x02
	//##ModelId=38F5FEC000F1
		BYTE		Reserved1;
	//##ModelId=38F5FEC000E7
		UINT32	Length;
	//##ModelId=38F5FEC000CB
		UINT16	ProtocolVersion;	// 0x01
	//##ModelId=38F5FEC000BF
		UINT16	Reserved2;
	public:
	//##ModelId=38F5FEC00097
		BYTE		CalledApTitle[17];	// 16 bytes transfered
	//##ModelId=38F5FEC00079
		BYTE		CallingApTitle[17];	// 16 bytes transfered
	//##ModelId=38F5FEC00065
		BYTE		Reserved3[32];
	//##ModelId=38F5FEC0005B
		ApplicationContext					AppContext;
	//##ModelId=38F5FEBF03CC
		Array<PresentationContextAccept>	PresContextAccepts;
	//##ModelId=38F5FEBF0372
		UserInformation						UserInfo;
	public:
	//##ModelId=38F5FEC003B8
					AAssociateAC();
	//##ModelId=38F5FEC003CC
					AAssociateAC(BYTE	*, BYTE	*);
	//##ModelId=38F5FEC0039A
		virtual			~AAssociateAC();
	//##ModelId=38F5FEC00368
		void		SetCalledApTitle(BYTE	*);
	//##ModelId=38F5FEC00336
		void		SetCallingApTitle(BYTE	*);
	//##ModelId=38F5FEC00304
		void		SetApplicationContext(ApplicationContext &);
	//##ModelId=38F5FEC001FF
		void		AddPresentationContextAccept(PresentationContextAccept &);
	//##ModelId=38F5FEC001CD
		void		SetUserInformation(UserInformation &);
	//##ModelId=38F5FEC001A5
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEC00173
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEC0014B
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEC00137
		UINT32		Size();
	};			


