/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/

/***********************************************************************
 * PDU Service Classes: 
 *	A-ASSOCIATE-RJ Class.  
 *	A-RELEASE-RQ Class.
 * 	A-RELEASE-RP Class.
 *	A-ABORT-RQ Class.
 *
 * Base Classes:
 *
 *
 *
 *
 *********************************************************************/
		

//##ModelId=38F5FEEA005B
class	AAssociateRJ
	{
	private:
	//##ModelId=38F5FEEA0137
		BYTE		ItemType;		// 0x03
	//##ModelId=38F5FEEA0119
		BYTE		Reserved1;
	//##ModelId=38F5FEEA010F
		UINT32		Length;
	//##ModelId=38F5FEEA00E7
		BYTE		Reserved2;
	public:
	//##ModelId=38F5FEEA00DD
		BYTE		Result;
	//##ModelId=38F5FEEA00C9
		BYTE		Source;
	//##ModelId=38F5FEEA00B5
		BYTE		Reason;

	//##ModelId=38F5FEEA03A4
					AAssociateRJ();
	//##ModelId=38F5FEEA03B8
					AAssociateRJ(BYTE, BYTE, BYTE);
	//##ModelId=38F5FEEA0390
		virtual		~AAssociateRJ();
	//##ModelId=38F5FEEA02DC
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEEA021E
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEEA0173
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEEA015F
		UINT32		Size();
	};			


//##ModelId=38F5FEFF0065
class	AReleaseRQ
	{
	private:
	//##ModelId=38F5FEFF0124
		BYTE		ItemType;		// 0x04
	//##ModelId=38F5FEFF0110
		BYTE		Reserved1;
	//##ModelId=38F5FEFF0106
		UINT32		Length;
	//##ModelId=38F5FEFF00F1
		UINT32		Reserved2;
	public:
	//##ModelId=38F5FEFF034A
					AReleaseRQ();
	//##ModelId=38F5FEFF0340
		virtual		~AReleaseRQ();
	//##ModelId=38F5FEFF0296
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEFF01EC
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEFF0142
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEFF0138
		UINT32		Size();
	};			

//##ModelId=38F5FEFA0054
class	AReleaseRP
	{
	private:
	//##ModelId=38F5FEFA00FE
		BYTE		ItemType;		// 0x06
	//##ModelId=38F5FEFA00EA
		BYTE		Reserved1;
	//##ModelId=38F5FEFA00E0
		UINT32		Length;
	//##ModelId=38F5FEFA00CE
		UINT32		Reserved2;
	public:
	//##ModelId=38F5FEFA0325
					AReleaseRP();
	//##ModelId=38F5FEFA0311
		virtual		~AReleaseRP();
	//##ModelId=38F5FEFA0267
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEFA01C7
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEFA011C
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEFA0112
		UINT32		Size();
	};			

//##ModelId=38F5FEF202BF
class	AAbortRQ
	{
	private:
	//##ModelId=38F5FEF203B0
		BYTE		ItemType;		// 0x07
	//##ModelId=38F5FEF20392
		BYTE		Reserved1;
	//##ModelId=38F5FEF20380
		UINT32		Length;
	//##ModelId=38F5FEF20360
		BYTE		Reserved2;
	//##ModelId=38F5FEF20342
		BYTE		Reserved3;
	public:
	//##ModelId=38F5FEF20338
		BYTE		Source;
	//##ModelId=38F5FEF20324
		BYTE		Reason;

	//##ModelId=38F5FEF30249
					AAbortRQ();
	//##ModelId=38F5FEF3025D
					AAbortRQ(BYTE, BYTE);
	//##ModelId=38F5FEF3022B
		virtual		~AAbortRQ();
	//##ModelId=38F5FEF3016C
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEF300AE
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEF203E2
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEF203CE
		UINT32		Size();
	};			

