/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/

/***********************************************************************
 * PDU Service Classes:
 *	A-ASSOCIATE-RQ Class.  
 *
 * Base Classes:
 *	UID
 *	ApplicationContext
 *	AbstractSyntax
 *	TransferSyntax
 *	PresentationContext
 *	MaximumSubLength
 *	ImplementationClass
 *	ImplementationVersion
 *	UserInformation
 *
 *
 *
 *********************************************************************/
//##ModelId=38F5FEF6021B
class	UID
	{
	//##ModelId=38F5FEF602E3
	UINT	Length;
	//##ModelId=38F5FEF602CF
	BYTE	uid[65];
	
	public:
	//##ModelId=38F5FEF7001E
			UID()	{ ZeroMem(uid, 64); Length = 0; };
	//##ModelId=38F5FEF70028
			UID(BYTE *s) { Set ( s ); };
	//##ModelId=38F5FEF70050
			UID(char *s) { Set ( (BYTE*)s ); };
	//##ModelId=38F5FEF60398
			void	Set(BYTE *s)
				{
				if(!s)
					return;
				ZeroMem(uid, 64);
				strcpy((char *) uid, (char *) s);
				Length = strlen((char*) uid);
				};
	//##ModelId=38F5FEF603C0
			void	Set(UID	&u) { (*this) = u; };
	//##ModelId=38F5FEF603DE
			void	Set(char *s) { this->Set((BYTE *) s); };
	//##ModelId=38F5FEF60379
			BYTE	*GetBuffer(UINT Min) { return(&uid[0]); };
	//##ModelId=38F5FEF6035B
			void	SetLength(UINT	L)	{ Length = L; while (L < 65) uid[L++] = '\0'; };
	//##ModelId=38F5FEF60347
			UINT	GetSize()	{ return ( Length ); };
	//##ModelId=38F5FEF60329
			BOOL	operator	==	(UID &ud)
				{ 	//if(GetSize()!=ud.GetSize()) return(FALSE);
					if(!strcmp((char*) GetBuffer(1), (char*) ud.GetBuffer(1)/*, (int) GetSize()*/))
						return(TRUE);
					return(FALSE); };
	//##ModelId=38F5FEF60315
			BOOL	operator	!=	(UID &ud) { return (!((*this)==ud));
};
	//##ModelId=38F5FEF602F7
			BOOL	operator	=	(UID &ud)
				{	ByteCopy(uid, ud.GetBuffer(1), 64);
					SetLength(ud.GetSize());
					
					return(TRUE);
				}
	};

//##ModelId=38F5FF1200F9
class	ApplicationContext
	{
	private:
	//##ModelId=38F5FF12024D
		BYTE		ItemType;		// 0x10
	//##ModelId=38F5FF120239
		BYTE		Reserved1;
	//##ModelId=38F5FF120225
		UINT16		Length;
	public:
	//##ModelId=38F5FF1201FD
		UID			ApplicationContextName;

	//##ModelId=38F5FF12032A
					ApplicationContext();
	//##ModelId=38F5FF120334
					ApplicationContext(UID	&);
	//##ModelId=38F5FF12035C
					ApplicationContext(BYTE *);
	//##ModelId=38F5FF120316
					~ApplicationContext();
	//##ModelId=38F5FF1202CF
		void		Set(UID	&);
	//##ModelId=38F5FF1202F8
		void		Set(BYTE *);
	//##ModelId=38F5FF1202B1
		BOOL		Write(Buffer &);
	//##ModelId=38F5FF120293
		BOOL		Read(Buffer &);
	//##ModelId=38F5FF120275
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FF12026B
		UINT32	Size();
	};

//##ModelId=38F5FEE6010A
class	AbstractSyntax
	{
	private:
	//##ModelId=38F5FEE601BE
		BYTE		ItemType;	// 0x30
	//##ModelId=38F5FEE601AA
		BYTE		Reserved1;
	//##ModelId=38F5FEE601A0
		UINT16		Length;
	public:
	//##ModelId=38F5FEE6018C
		UID			AbstractSyntaxName;
	//##ModelId=38F5FEE60286
					AbstractSyntax();
	//##ModelId=38F5FEE60290
					AbstractSyntax(BYTE *);
	//##ModelId=38F5FEE602B8
					AbstractSyntax(UID &);
	//##ModelId=38F5FEE60272
					~AbstractSyntax();
	//##ModelId=38F5FEE60236
		void		Set(UID	&);
	//##ModelId=38F5FEE60254
		void		Set(BYTE *);
	//##ModelId=38F5FEE60218
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEE601FA
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEE601DC
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEE601D2
		UINT32	Size();

	};

//##ModelId=38F5FEE200E6
class	TransferSyntax
	{
	private:
	//##ModelId=38F5FEE201A4
		BYTE		ItemType;	// 0x40
	//##ModelId=38F5FEE20190
		BYTE		Reserved1;
	//##ModelId=38F5FEE2017E
		UINT16		Length;
	public:
	//##ModelId=38F5FEE20172
		UID			TransferSyntaxName;
	//##ModelId=38F5FEE2015E
		UINT		EndianType;
	//##ModelId=38F5FEE2029E
					TransferSyntax();
	//##ModelId=38F5FEE202A8
					TransferSyntax(BYTE *);
	//##ModelId=38F5FEE203C1
					TransferSyntax(UID &);
	//##ModelId=38F5FEE20294
					~TransferSyntax();
	//##ModelId=38F5FEE2024E
		void		Set(UID	&);
	//##ModelId=38F5FEE2026C
		void		Set(BYTE *);
	//##ModelId=38F5FEE20226
		void		SetType(UINT	T) { EndianType = T; };
	//##ModelId=38F5FEE20208
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEE201EA
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEE201C2
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEE201B8
		UINT32	Size();

	};

//##ModelId=38F5FEF502EC
class	ImplementationClass
	{
	private:
	//##ModelId=38F5FEF50396
		BYTE		ItemType;	// 0x52
	//##ModelId=38F5FEF50382
		BYTE		Reserved1;
	//##ModelId=38F5FEF50370
		UINT16		Length;
	public:
	//##ModelId=38F5FEF50364
		UID			ImplementationName;
	//##ModelId=38F5FEF50350
		UINT		EndianType;
	//##ModelId=38F5FEF6008A
					ImplementationClass();
	//##ModelId=38F5FEF6009E
					ImplementationClass(BYTE *);
	//##ModelId=38F5FEF600C6
					ImplementationClass(UID &);
	//##ModelId=38F5FEF60080
					~ImplementationClass();
	//##ModelId=38F5FEF6003A
		void		Set(UID	&);
	//##ModelId=38F5FEF60058
		void		Set(BYTE *);
	//##ModelId=38F5FEF60012
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEF503DC
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEF503BE
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEF503AA
		UINT32	Size();

	};


//##ModelId=38F5FF06001F
class	ImplementationVersion
	{
	private:
	//##ModelId=38F5FF060138
		BYTE		ItemType;	// 0x55
	//##ModelId=38F5FF060124
		BYTE		Reserved1;
	//##ModelId=38F5FF060110
		UINT16		Length;
	public:
	//##ModelId=38F5FF0600E0
		UID			Version;
	//##ModelId=38F5FF0600C9
		UINT		EndianType;
	//##ModelId=38F5FF060228
					ImplementationVersion();
	//##ModelId=38F5FF060232
					ImplementationVersion(BYTE *);
	//##ModelId=38F5FF06025A
					ImplementationVersion(UID &);
	//##ModelId=38F5FF06020A
					~ImplementationVersion();
	//##ModelId=38F5FF0601C4
		void		Set(UID	&);
	//##ModelId=38F5FF0601E2
		void		Set(BYTE *);
	//##ModelId=38F5FF06019C
		BOOL		Write(Buffer &);
	//##ModelId=38F5FF06017E
		BOOL		Read(Buffer &);
	//##ModelId=38F5FF060160
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FF060156
		UINT32	Size();

	};


//##ModelId=38F5FF0700AD
class	SCPSCURoleSelect
	{
	private:
	//##ModelId=38F5FF0701E3
		BYTE		ItemType;	// 0x54
	//##ModelId=38F5FF0701C5
		BYTE		Reserved1;
	//##ModelId=38F5FF0701BB
		UINT16		Length;
	public:
	//##ModelId=38F5FF070193
		UID			uid;
	//##ModelId=38F5FF07017F
		BYTE		SCURole;
	//##ModelId=38F5FF07016B
		BYTE		SCPRole;
	//##ModelId=38F5FF070298
					SCPSCURoleSelect();
	//##ModelId=38F5FF070284
					~SCPSCURoleSelect();
	//##ModelId=38F5FF070266
		BOOL		Write(Buffer &);
	//##ModelId=38F5FF07023D
		BOOL		Read(Buffer &);
	//##ModelId=38F5FF07020B
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FF070201
		UINT32		Size();

	};


		
//##ModelId=38F5FEDE00FE
class	PresentationContext
	{
	private:
	//##ModelId=38F5FEDE0285
		BYTE							ItemType;	// 0x20
	//##ModelId=38F5FEDE025D
		BYTE							Reserved1;
	//##ModelId=38F5FEDE0253
		UINT16							Length;
	public:
	//##ModelId=38F5FEDE0234
		BYTE							PresentationContextID;
	private:
	//##ModelId=38F5FEDE0216
		BYTE							Reserved2;
	//##ModelId=38F5FEDE0202
		BYTE							Reserved3;
	//##ModelId=38F5FEDE01EE
		BYTE							Reserved4;
	public:
	//##ModelId=38F5FEDE01E4
		AbstractSyntax				AbsSyntax;
	//##ModelId=38F5FEDE01BE
		Array<TransferSyntax>		TrnSyntax;
	//##ModelId=38F5FEDE03A7
					PresentationContext();
	//##ModelId=38F5FEDE03BB
					PresentationContext(AbstractSyntax &, TransferSyntax &);
	//##ModelId=38F5FEDE039D
					~PresentationContext();
	//##ModelId=38F5FEDE036B
		void		SetAbstractSyntax(AbstractSyntax	&);
	//##ModelId=38F5FEDE0339
		void		AddTransferSyntax(TransferSyntax	&);
	//##ModelId=38F5FEDE0311
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEDE02DF
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEDE02B7
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEDE02A3
		UINT32	Size();
		
	};

//##ModelId=38F5FEDC0390
class	MaximumSubLength
	{
	private:
	//##ModelId=38F5FEDD0020
		BYTE						ItemType;	// 0x51
	//##ModelId=38F5FEDD000C
		BYTE						Reserved1;
	//##ModelId=38F5FEDD0004
		UINT16						Length;
	//##ModelId=38F5FEDC03E0
		UINT32						MaximumLength;
	public:
	//##ModelId=38F5FEDD00D5
					MaximumSubLength();
	//##ModelId=38F5FEDD00DF
					MaximumSubLength(UINT32);
	//##ModelId=38F5FEDD00C1
					~MaximumSubLength();
	//##ModelId=38F5FEDD00A2
		void		Set(UINT32);
	//##ModelId=38F5FEDD0098
		UINT32		Get();
	//##ModelId=38F5FEDD007A
		BOOL		Write(Buffer &);
	//##ModelId=38F5FEDD005C
		BOOL		Read(Buffer &);
	//##ModelId=38F5FEDD0048
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FEDD003E
		UINT32	Size();
	};

//##ModelId=38F5FF000229
class	UserInformation
	{
	private:
	//##ModelId=38F5FF000392
		BYTE						ItemType;	// 0x50
	//##ModelId=38F5FF000374
		BYTE						Reserved1;
	//##ModelId=38F5FF00036A
		UINT16						Length;
	public:
	//##ModelId=38F5FF00034C
		UINT32						UserInfoBaggage;
	//##ModelId=38F5FF000324
		MaximumSubLength			MaxSubLength;
	//##ModelId=38F5FF0002F4
		ImplementationClass			ImpClass;
	//##ModelId=38F5FF0002E0
		ImplementationVersion		ImpVersion;
	//##ModelId=38F5FF0002D4
		SCPSCURoleSelect			SCPSCURole;
	public:
	//##ModelId=38F5FF01007C
					UserInformation();
	//##ModelId=38F5FF010072
					~UserInformation();
	//##ModelId=38F5FF01004A
		void		SetMax(MaximumSubLength	&);
	//##ModelId=38F5FF010040
		UINT32		GetMax();
	//##ModelId=38F5FF010018
		BOOL		Write(Buffer &);
	//##ModelId=38F5FF0003D8
		BOOL		Read(Buffer &);
	//##ModelId=38F5FF0003BA
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FF0003B0
		UINT32		Size();
	};

//##ModelId=38F5FF0D0228
class	AAssociateRQ
	{
	private:
	//##ModelId=38F5FF0E00F3
		BYTE		ItemType;		// 0x01
	//##ModelId=38F5FF0E00CB
		BYTE		Reserved1;
	//##ModelId=38F5FF0E00C1
		UINT32	Length;
	//##ModelId=38F5FF0E00AD
		UINT16	ProtocolVersion;	// 0x01
	//##ModelId=38F5FF0E008F
		UINT16	Reserved2;
	public:
	//##ModelId=38F5FF0E0071
		BYTE		CalledApTitle[17];	// 16 bytes transfered
	//##ModelId=38F5FF0E005D
		BYTE		CallingApTitle[17];	// 16 bytes transfered
	//##ModelId=38F5FF0E003F
		BYTE		Reserved3[32];

	//##ModelId=38F5FF0E0035
		ApplicationContext			AppContext;
	//##ModelId=38F5FF0E000D
		Array<PresentationContext>	PresContexts;
	//##ModelId=38F5FF0D02FA
		UserInformation				UserInfo;
	public:
	//##ModelId=38F5FF100042
					AAssociateRQ();
	//##ModelId=38F5FF10004C
					AAssociateRQ(BYTE	*, BYTE	*);
	//##ModelId=38F5FF100024
		virtual		~AAssociateRQ();
	//##ModelId=38F5FF0F034D
		void		SetCalledApTitle(BYTE	*);
	//##ModelId=38F5FF0F0271
		void		SetCallingApTitle(BYTE	*);
	//##ModelId=38F5FF0F00FF
		void		SetApplicationContext(ApplicationContext &);
	//##ModelId=38F5FF0F01B3
		void		SetApplicationContext(UID &);
	//##ModelId=38F5FF0F0040
		void		AddPresentationContext(PresentationContext &);
	//##ModelId=38F5FF0F002C
		void		ClearPresentationContexts();
	//##ModelId=38F5FF0E0360
		void		SetUserInformation(UserInformation &);
	//##ModelId=38F5FF0E02A2
		BOOL		Write(Buffer &);
	//##ModelId=38F5FF0E01E3
		BOOL		Read(Buffer &);
	//##ModelId=38F5FF0E012F
		BOOL		ReadDynamic(Buffer	&);
	//##ModelId=38F5FF0E011B
		UINT32		Size();
	};			


