/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/


//##ModelId=38F5FF070338
class	CEchoRQ
	{
	public:
	//##ModelId=38F5FF080036
		BOOL	Read ( DICOMCommandObject * );
	//##ModelId=38F5FF080018
		BOOL	Write ( PDU_Service * );
	//##ModelId=38F5FF080004
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FED50368
class	CEchoRSP
	{
	public:
	//##ModelId=38F5FED60016
		BOOL	Read ( DICOMCommandObject * );
	//##ModelId=38F5FED503C2
		BOOL	Write ( PDU_Service *, DICOMCommandObject *, UINT16 );
	//##ModelId=38F5FED503E0
		BOOL	Write ( PDU_Service *, DICOMCommandObject * );
	//##ModelId=38F5FED503AE
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FED90039
class	CStoreRQ
	{
	public:
	//##ModelId=38F5FED900F7
		BOOL	Read (	DICOMCommandObject *,
						PDU_Service *,
						DICOMDataObject * );
	//##ModelId=38F5FED9016F
		BOOL	Read (	DICOMCommandObject	* );
	//##ModelId=38F5FED900A7
		BOOL	Write ( PDU_Service * , DICOMDataObject	*);
	//##ModelId=38F5FED9007F
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FEEF01E9
class	CStoreRSP
	{
	public:
	//##ModelId=38F5FEEF03D4
		BOOL	Read ( DICOMCommandObject * );
	//##ModelId=38F5FEEF027F
		BOOL	Write ( PDU_Service * , DICOMCommandObject *, UINT16 );
	//##ModelId=38F5FEEF0351
		BOOL	Write ( PDU_Service *, DICOMCommandObject * );
	//##ModelId=38F5FEEF0243
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FED601C5
class	CFindRQ
	{
	public:
	//##ModelId=38F5FED60233
		BOOL	Read (	DICOMCommandObject *,
						PDU_Service *,
						DICOMDataObject * );
	//##ModelId=38F5FED6025B
		BOOL	Read (	DICOMCommandObject	* );
	//##ModelId=38F5FED60216
		BOOL	Write ( PDU_Service * , DICOMDataObject	*);
	//##ModelId=38F5FED6020B
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FF0802E9
class	CFindRSP
	{
	public:
	//##ModelId=38F5FF090114
		BOOL	Read (	DICOMCommandObject *,
						PDU_Service	*,
						DICOMDataObject	* );
	//##ModelId=38F5FF0901A0
		BOOL	Read (	DICOMCommandObject	* );
	//##ModelId=38F5FF0803BB
		BOOL	Write ( PDU_Service *,
						DICOMCommandObject *,
						UINT16,
						DICOMDataObject	*);
	//##ModelId=38F5FF090088
		BOOL	Write ( PDU_Service *,
						DICOMCommandObject *,
						DICOMDataObject * );
	//##ModelId=38F5FF080393
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FEF70277
class	CMoveRQ
	{
	public:
	//##ModelId=38F5FEF703A3
		BOOL	Read (	DICOMCommandObject *,
						PDU_Service *,
						DICOMDataObject * );
	//##ModelId=38F5FEF80051
		BOOL	Read (	DICOMCommandObject	* );
	//##ModelId=38F5FEF70317
		BOOL	Write ( PDU_Service * , DICOMDataObject	*, BYTE *);
	//##ModelId=38F5FEF702E5
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FED70022
class	CMoveRSP
	{
	public:
	//##ModelId=38F5FED700E0
		BOOL	Read (	DICOMCommandObject *,
						PDU_Service	*,
						DICOMDataObject	* );
	//##ModelId=38F5FED70108
		BOOL	Read (	DICOMCommandObject * );
	//##ModelId=38F5FED7007C
		BOOL	Write ( PDU_Service *,
						DICOMCommandObject *,
						UINT16,
						UINT16,
						UINT16,
						UINT16,
						UINT16,
						DICOMDataObject *);
	//##ModelId=38F5FED70068
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

