#ifndef	_DIMSEN_HPP
#	define	_DIMSEN_HPP

#	define	N_EVENT_REPORT_RQ	0x0100
#	define	N_EVENT_REPORT_RSP	0x8100
#	define	N_GET_RQ			0x0110
#	define	N_GET_RSP			0x8110
#	define	N_SET_RQ			0x0120
#	define	N_SET_RSP			0x8120
#	define	N_ACTION_RQ			0x0130
#	define	N_ACTION_RSP		0x8130
#	define	N_CREATE_RQ			0x0140
#	define	N_CREATE_RSP		0x8140
#	define	N_DELETE_RQ			0x0150
#	define	N_DELETE_RSP		0x8150

VR		*TranslateUIDToVR ( UID *, UINT16, UINT16 );

//##ModelId=38F5FEDF0380
class	NEventReportRQ
	{
	public:
	//##ModelId=38F5FEE00057
		BOOL	Read ( DICOMCommandObject *,
					PDU_Service *PDU=NULL,
					DICOMDataObject *DDO=NULL );
	//##ModelId=38F5FEDF03E5
		BOOL	Write ( PDU_Service *,
						DICOMDataObject *DDO,
						UID		*AffectedSOPInstanceUID,
						UINT16	EventID);
	//##ModelId=38F5FEE0002F
		BOOL	Write ( PDU_Service *PDU,
						UID		*AffectedSOPInstanceUID,
						UINT16	EventID);
	//##ModelId=38F5FEDF03D1
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FF0903BD
class	NEventReportRSP
	{
	public:

	//##ModelId=38F5FF0A0115
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service	*PDU = NULL,
						DICOMDataObject *DDO = NULL );
	//##ModelId=38F5FF0A009D
		BOOL	Write ( PDU_Service *,
						DICOMCommandObject *,
						UID			*AffectedSOPInstanceUID,
						UINT16		Status,
						UINT16		EventID,
						DICOMDataObject *DDO = NULL);
	//##ModelId=38F5FF0A00D9
		BOOL	Write ( PDU_Service *,
						DICOMCommandObject *,
						UID			*AffectedSOPInstanceUID,
						UINT16		EventID,
						DICOMDataObject *DDO = NULL);
	//##ModelId=38F5FF0A0089
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FEE700CF
class	NGetRQ
	{
	public:
	//##ModelId=38F5FEE701A1
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service	*PDU = NULL,
						DICOMDataObject	*DDO = NULL);
	//##ModelId=38F5FEE70147
		BOOL	Write ( PDU_Service	*,
						DICOMDataObject *DDO,
						UID			*RequestedSOPInstanceUID);
	//##ModelId=38F5FEE70183
		BOOL	Write ( PDU_Service *PDU,
						UID			*RequestedSOPInstnaceUID );
		
	//##ModelId=38F5FEE70133
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FEFE0118
class	NGetRSP
	{
	public:
	//##ModelId=38F5FEFE01D6
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service *PDU = NULL,
						DICOMDataObject *DDO = NULL);
	//##ModelId=38F5FEFE01A4
		BOOL	Write ( PDU_Service *PDU,
						DICOMCommandObject *,
						UID		*AffectedSOPInstanceUID,
						UINT16	Status = 0,
						DICOMDataObject	*DDO = NULL);
	//##ModelId=38F5FEFE0190
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FEC10229
class	NSetRQ
	{
	public:
	//##ModelId=38F5FEC102B5
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service *PDU = NULL,
						DICOMDataObject *DDO = NULL );
	//##ModelId=38F5FEC1026F
		BOOL	Write ( PDU_Service *PDU,
						DICOMDataObject *DDO,
						UID		*RequestedSOPInstanceUID );
	//##ModelId=38F5FEC10297
		BOOL	Write ( PDU_Service *PDU,
						UID			*RequestedSOPInstnaceUID );
	//##ModelId=38F5FEC1025B
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FEBD02D7
class	NSetRSP
	{
	public:
	//##ModelId=38F5FEBD0363
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service *PDU = NULL,
						DICOMDataObject *DDO = NULL );
	//##ModelId=38F5FEBD0327
		BOOL	Write ( PDU_Service *PDU,
						DICOMCommandObject *,
						UID		*AffectedSOPInstanceUID,
						UINT16	Status = 0,
						DICOMDataObject	*DDO = NULL);
	//##ModelId=38F5FEBD0309
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FEF00226
class	NActionRQ
	{
	public:
	//##ModelId=38F5FEF002F9
		BOOL	Read ( DICOMCommandObject *,
					PDU_Service *PDU=NULL,
					DICOMDataObject *DDO=NULL );
	//##ModelId=38F5FEF0029F
		BOOL	Write ( PDU_Service *,
						DICOMDataObject *,
						UID		*RequestedSOPInstanceUID,
						UINT16	ActionTypeID);
	//##ModelId=38F5FEF002D1
		BOOL	Write ( PDU_Service *,
						UID		*RequestedSOPInstanceUID,
						UINT16	ActionTypeID);
	//##ModelId=38F5FEF00280
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FEDF00EB
class	NActionRSP
	{
	public:
	//##ModelId=38F5FEDF0196
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service *PDU = NULL,
						DICOMDataObject *DDO = NULL );
	//##ModelId=38F5FEDF015A
		BOOL	Write ( PDU_Service *PDU,
						DICOMCommandObject *,
						UID		*AffectedSOPInstanceUID,
						UINT16	ActionTypeID,
						UINT16	Status = 0,
						DICOMDataObject	*DDO = NULL);
	//##ModelId=38F5FEDF0146
		virtual	BOOL	GetUID ( UID & ) = 0;
	};


//##ModelId=38F5FEEE013D
class	NCreateRQ
	{
	public:
	//##ModelId=38F5FEEE01FB
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service *PDU = NULL,
						DICOMDataObject *DDO = NULL );
	//##ModelId=38F5FEEE01B5
		BOOL	Write ( PDU_Service *PDU,
						DICOMDataObject *DDO,
						UID		*AffectedSOPInstanceUID );
	//##ModelId=38F5FEEE01DD
		BOOL	Write ( PDU_Service *PDU,
						UID		*AffectedSOPInstanceUID );
	//##ModelId=38F5FEEE01A1
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FF1502C0
class	NCreateRSP
	{
	public:
	//##ModelId=38F5FF160004
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service *PDU = NULL,
						DICOMDataObject *DDO = NULL );
	//##ModelId=38F5FF1503B1
		BOOL	Write ( PDU_Service *PDU,
						DICOMCommandObject *,
						UID		*AffectedSOPInstanceUID,
						UINT16	Status = 0,
						DICOMDataObject	*DDO = NULL);
	//##ModelId=38F5FF15039C
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FED90269
class	NDeleteRQ
	{
	public:
	//##ModelId=38F5FED902D8
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service *PDU = NULL);
	//##ModelId=38F5FED902C4
		BOOL	Write ( PDU_Service *PDU,
						UID		*RequestedSOPInstanceUID );
	//##ModelId=38F5FED902AF
		virtual	BOOL	GetUID ( UID & ) = 0;
	};

//##ModelId=38F5FED701E4
class	NDeleteRSP
	{
	public:
	//##ModelId=38F5FED70271
		BOOL	Read ( DICOMCommandObject *,
						PDU_Service *PDU = NULL);
	//##ModelId=38F5FED70248
		BOOL	Write ( PDU_Service *PDU,
						DICOMCommandObject *,
						UID		*AffectedSOPInstanceUID,
						UINT16	Status = 0);
	//##ModelId=38F5FED70234
		virtual	BOOL	GetUID ( UID & ) = 0;
	};


#endif

