/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/

/****************************************************************************
 *
 * Abstract Base Class for P-DATA Service
 *
 *
 ****************************************************************************/


//##ModelId=38F5FF0A0292
class	LinkedBuffer	:
	public	Buffer
	{
	//##ModelId=38F5FF0A036E
		Buffer	*LinkedTo;
	public:
	//##ModelId=38F5FF0B00A9
			LinkedBuffer()	{ LinkedTo = NULL; };
	//##ModelId=38F5FF0B009F
			~LinkedBuffer()	{ LinkedTo = NULL; };
	//##ModelId=38F5FF0B0059
		BOOL	Fill(Buffer	&Link, UINT	Count);
	//##ModelId=38F5FF0B001C
		BOOL	Flush(Buffer &Link, UINT	Count);
	//##ModelId=38F5FF0B0008
		UINT	GetOutgoingSize();
	//##ModelId=38F5FF0A03E6
		UINT	GetIncomingSize();
	//##ModelId=38F5FF0A03AA
		virtual	INT		ReadBinary(BYTE	*Data, UINT	Count);
	//##ModelId=38F5FF0A0378
		virtual	BOOL	SendBinary(BYTE *Data, UINT Count);
	};

//##ModelId=38F5FF0B01B7
class	MemoryBuffer	:
	public	LinkedBuffer
	{
	private:
	//##ModelId=38F5FF0B0316
		BYTE		*Data;
	//##ModelId=38F5FF0B0301
		UINT		Length;
	//##ModelId=38F5FF0B02ED
		UINT		Index;
	//##ModelId=38F5FF0B02E3
		BOOL		DestructFlag;
	public:
	//##ModelId=38F5FF0B03B6
		INT		ReadBinary(BYTE	*Data, UINT	Count);
	//##ModelId=38F5FF0B0384
		BOOL	SendBinary(BYTE *Data, UINT Count);
	//##ModelId=38F5FF0B0334
				MemoryBuffer ( BYTE *Data, UINT Length, BOOL Destruct,
								UINT Endian);
	//##ModelId=38F5FF0B032A
				~MemoryBuffer ();
	};


//##ModelId=38F5FEFE0230
class	PDV
	{
	public:
	//##ModelId=38F5FEFE02E7
		UINT32	Length;
	//##ModelId=38F5FEFE02C7
		BYTE	PresentationContextID;
	//##ModelId=38F5FEFE02BD
		BYTE	MsgHeader;
	};

//##ModelId=38F5FEBE00D0
class	PDataTF
	{
	private:
	//##ModelId=38F5FEBE0198
		BYTE			ItemType;	// 0x04
	//##ModelId=38F5FEBE0170
		BYTE			Reserved1;
	public:
	//##ModelId=38F5FEBE0166
		UINT32			Length;
	public:
	//##ModelId=38F5FEBE0152
		LinkedBuffer	VRBuffer;

	public:
	//##ModelId=38F5FEBE0134
		INT		MsgStatus;
	//##ModelId=38F5FEBE0120
		UINT	Endian;
	//##ModelId=38F5FEBE0118
		PDV		pdv;
	//##ModelId=38F5FEBE0102
		BYTE	PresentationContextID;
	//##ModelId=38F5FEBE00F8
		BYTE	MsgHeader;

	//##ModelId=38F5FEBE0210
		BOOL	ReadDynamic(Buffer	&Link);
	//##ModelId=38F5FEBE01E8
		BOOL	Write(Buffer	&Link);

	//##ModelId=38F5FEBE01D4
				PDataTF();
	//##ModelId=38F5FEBE01C0
		virtual		~PDataTF();
	};

