#	include	"dicom.hpp"

#	define	CECHO_SERVER	1
#	define	CECHO_CLIENT	2
#	define	CFIND_CLIENT	3
#	define	CSTORE_SERVER	4
#	define	CMOVE_CLIENT	5
#	define	CECHOSTORE_SERVER	6
#	define	CDUMPFILE		7

#ifdef	MAC
#	undef	stdout
#	define	stdout	stderr
#endif

	int		ForkAProc;
	BOOL	(*ForkProc)(DICOMDataObject *);

RTC		VRType(TRUE);

BYTE	LOCAL_ACR[20]	=	"none";
BYTE	REMOTE_ACR[20]	=	"none";
BYTE	PORT[20]	=		"10004";
BYTE	Directory[128]	=	".\\";
BYTE	PNAME[64]		=	"\0";

class	PolaroidPDU_Service	:
	public	PDU_Service
	{
	public:
		BOOL	FixPolaroidConnection()
			{
			UINT	Index;
			UID		uidbad("1.2.840.10008.1.1");
			UID		uidgood("1.2.840.10008.1.2");
			
			Index = 0;
			while ( Index < AcceptedPresentationContexts.GetSize() )
				{
				if (AcceptedPresentationContexts.Get(Index).TrnSyntax.TransferSyntaxName
						== uidbad )
					AcceptedPresentationContexts.Get(Index).TrnSyntax.TransferSyntaxName
						= uidgood;
				++Index;
				}
			return ( TRUE );
			}					
	};
	
	
void
Dump (
	AAssociateRQ	&ARQ)
	{
	char	s[128];

	printf("A-ASSOCIATE-RQ Packet Dump\n\n");
	memset(s, 0, 64);
	memcpy(s, ARQ.CallingApTitle, 16);
	printf("\tCalling Application Title : \"%s\"\n", s);
	memset(s, 0, 64);
	memcpy(s, ARQ.CalledApTitle, 16);
	printf("\tCalled Application Title : \"%s\"\n", s);
	memset(s, 0, 64);
	memcpy(s, ARQ.AppContext.ApplicationContextName.GetBuffer(1),
		ARQ.AppContext.ApplicationContextName.GetSize() );
	printf("\tApplication Context : \"%s\"\n", s);
	printf("\tNumber of Proposed Presentation Contexts: %d\n",
		ARQ.PresContexts.GetSize() );

	int	Index = 0;
	int	Index2 = 0;
	while (Index < ARQ.PresContexts.GetSize() )
		{
		PresentationContext	PC;

		PC = ARQ.PresContexts.Get(Index);
		PC.TrnSyntax.ClearType = FALSE;

		memset(s, 0, 64);
		memcpy(s,
		PC.AbsSyntax.AbstractSyntaxName.GetBuffer(1),
			PC.AbsSyntax.AbstractSyntaxName.GetSize()%64 );

		printf("\t[%d] Presentation Context ID=%d : ABS=\"%s\"\n",
			Index, PC.PresentationContextID, s);
		Index2 = 0;
		while ( Index2 < PC.TrnSyntax.GetSize() )
			{
			memset(s, 0, 64);
			memcpy(s,
			PC.TrnSyntax.Get(Index2).TransferSyntaxName.GetBuffer(1),
				PC.TrnSyntax.Get(Index2).TransferSyntaxName.GetSize()%64 );

			printf("\t\tTransfer Syntax: \"%s\"\n",s);
			++Index2;
			}
		
		++Index;
		}
	}

void
Dump (
	AAssociateAC	&AAC)
	{
	char	s[128];

	printf("A-ASSOCIATE-AC Packet Dump\n\n");
	memset(s, 0, 64);
	memcpy(s, AAC.CallingApTitle, 16);
	printf("\tCalling Application Title : \"%s\"\n", s);
	memset(s, 0, 64);
	memcpy(s, AAC.CalledApTitle, 16);
	printf("\tCalled Application Title : \"%s\"\n", s);
	memset(s, 0, 64);
	memcpy(s, AAC.AppContext.ApplicationContextName.GetBuffer(1),
		AAC.AppContext.ApplicationContextName.GetSize() );
	printf("\tApplication Context : \"%s\"\n", s);
	printf("\tNumber of Accepted Presentation Contexts: %d\n",
		AAC.PresContextAccepts.GetSize() );

	int	Index = 0;
	while (Index < AAC.PresContextAccepts.GetSize() )
		{
		PresentationContextAccept	PC;

		PC = AAC.PresContextAccepts.Get(Index);

		memset(s, 0, 64);
		memcpy(s,
		PC.TrnSyntax.TransferSyntaxName.GetBuffer(1),
			PC.TrnSyntax.TransferSyntaxName.GetSize()%64 );

		printf("\t[%d] Presentation Context ID=%d\n\t\tTransfer Syntax: \"%s\"\n",
			Index, PC.PresentationContextID, s);
		++Index;
		}
	}

BOOL	IsAlpha(BYTE	c)
	{
	if((c >= ' ')&&(c <= 125))
		return ( TRUE );
	if(!c)
		return ( TRUE );
	return ( FALSE );
	}
			
BOOL	IsDataAlpha(UINT	Size, BYTE	*data)
	{
	if(Size > 16)
		Size = 16;
	if(!Size)
		return ( FALSE );
	--Size;
	while(Size)
		{
		if(!IsAlpha(data[Size]))
			return ( FALSE );
		--Size;
		}
	return ( TRUE );
	}
	
BOOL	PrintUDATA(UINT	Size, void	*data, UINT16	TypeCode)
	{
	UINT	Index = 0;
	char	*c;
	UINT16	tint16;
	UINT32	tint32;
	BYTE	*b;
	LE_UINT16	*w;
	char	Str[70];
	LE_UINT32	*l32 = (LE_UINT32*)data;
	LE_UINT16	*l16 = (LE_UINT16*)data;
	LE_INT32	*s32 = (LE_INT32*)data;
	LE_INT16	*s16 = (LE_INT16*)data;

	if(!data)
		{
		fprintf(stdout, "(null)");
		return ( TRUE );
		}
	if ( ! TypeCode )
		{
		switch ( Size )
			{
			case	2:
				tint16 = (*((UINT16 *) data));
				fprintf(stdout, "(%d|%x)", (UINT) tint16, (UINT) tint16);
				break;
			case	4:
				tint32 = (*((UINT32 *) data));
				fprintf(stdout, "[%d|%x]", (UINT) tint32, (UINT) tint32);
				break;
			default:
				if(IsDataAlpha(Size, (BYTE*) data))
					{
					if(Size > 64)
						Size = 64;
					strncpy(Str, (char*) data, Size);
					Str[Size] = '\0';
					fprintf(stdout, "\"%s\"", Str);
					break;
					}
				Index = 0;
				while(Index < Size)
					{
					if(Index >= 16)
						break;
					c = (char*)data;
					c += Index;
					fprintf(stdout, "%2.2x(%c)", *c, *c);
					++Index;
					}
			}
		}
	else
		{
		switch ( TypeCode )
			{
			case	'AE':
			case	'AS':
			case	'CS':
			case	'DA':
			case	'DS':
			case	'DT':
			case	'IS':
			case	'LO':
			case	'LT':
			case	'PN':
			case	'SH':
			case	'ST':
			case	'TM':
			case	'UI':
				if(Size > 64)
					Size = 64;
				strncpy(Str, (char*) data, Size);
				Str[Size] = '\0';
				fprintf(stdout, "\"%s\"", Str);
				break;
					
			case	'FL':
			case	'FD':
				break;				
			case	'AT':
				Index = 0;
				while ( Index < Size )
					{
					UINT16	Grp, Elm;
					
					Grp = (*l16);++l16;
					Elm = (*l16);++l16;
					fprintf(stdout, "(%4.4x, %4.4x) ", Grp, Elm);
					Index += 4;
					}
				break;
			case	'OB':
				b = (BYTE*)data;
				while ( Index < Size )
					{
					if ( Index > 10 )
						break;
					fprintf(stdout, "%2.2x ", b);
					++b;
					++Index;
					}
				break;
			case	'OW':
				w = (LE_UINT16*)data;
				
				while(Index < Size )
					{
					if ( Index > 20 )
						break;
					fprintf(stdout, "%4.4x ", (UINT16)(*w));
					++w;
					++Index;
					++Index;
					}
				break;
					
			case	'SQ':
				fprintf(stdout, "Sequence Item\n");
				break;
			case	'UL':
				
				while ( Index < Size )
					{
					if ( Index > 40 )
						break;
					
					fprintf(stdout, "%ld ", (UINT32)(*l32));
					++l32;
					Index += 4;
					}
				break;
			case    'UN';
				fprintf(stderr, "Unknown VR (UN)\n");
				break;
			case	'US':
				
				while ( Index < Size )
					{
					if ( Index > 20 )
						break;
					
					fprintf(stdout, "%d ", (UINT32)(*l16));
					++l16;
					Index += 2;
					}
				break;
			case	'SL':
				
				while ( Index < Size )
					{
					if ( Index > 40 )
						break;
					
					fprintf(stdout, "%ld ", (UINT32)(*s32));
					++s32;
					Index += 4;
					}
				break;
			case	'SS':
				
				while ( Index < Size )
					{
					if ( Index > 20 )
						break;
						
					fprintf(stdout, "%d ", (UINT32)(*s16));
					++s16;
					Index += 2;
					}
				break;
		
			}
		}
	return ( TRUE );
	}
	
	
BOOL	DumpVR(VR	*vr)
	{
	INT		Index;
	char	*c;
	UINT16	TypeCode;
	char	s[256];

	s[0] = '\0';
	TypeCode = 0;
	TypeCode = VRType.RunTimeClass(vr->Group, vr->Element, s);
	if(TypeCode)
		fprintf(stdout, "Object: (%4.4x, %4.4x, %d, %c%c, %s) ",
			vr->Group, vr->Element, vr->Length,
			TypeCode>>8, TypeCode&0x00ff, s);
	else
		fprintf(stdout, "Object: (%4.4x, %4.4x, %d, Type Unknown) ",
			vr->Group, vr->Element, vr->Length);
	PrintUDATA ( vr->Length, vr->Data, TypeCode );
	fprintf(stdout, "\n");
	return(TRUE);
	}

BOOL
DumpDDO(
	DICOMDataObject	*DDO,
	UINT			TabCount)
	{
	VR			*vr;
	while (vr = DDO->Pop())
		{
		UINT	Index = 0;
		while ( Index < TabCount)
			{
			fprintf(stdout, "\t");
			++Index;
			}
		DumpVR(vr);
		if ( vr->SQObjectArray )
			{
			Array < DICOMDataObject * > 	*ADDO =
				(Array<DICOMDataObject*>*) vr->SQObjectArray;
			
			Index = 0;
			while ( Index < ADDO->GetSize() )
				{
				fprintf(stdout, "> Start of Sequence\n");
				DumpDDO(ADDO->Get(Index), TabCount+1);
				fprintf(stdout, "> End of Sequence\n");
				++Index;
				}
			}
		delete vr;
		}
	return ( TRUE );
	}
	
BOOL
DumpDDOFile(char	*filename)
	{
	PDU_Service		PDU;
	DICOMDataObject	*DDO;
	VR				*vr;

	PDU.AttachRTC(&VRType);
	DDO = PDU.LoadDICOMDataObject(filename);
	if ( ! DDO )
		{
		fprintf(stderr, "Error loading filename: %s\n", filename);
		return ( FALSE );
		}
	fprintf(stdout, "[-------DICOM Object: %s--------]\n", filename);
	DumpDDO(DDO, 0);
	delete DDO;
	return ( TRUE );
	}

BOOL
CEchoServer()
	{
	PDU_Service			PDU;
	DICOMCommandObject	DCO;
	DICOMCommandObject	DCOR;
	VR					*vr;
	LE_UINT16				tuint16;

	if(PDU.Listen(PORT))
		{
		PDU.Read(&DCO);

		while(vr = DCO.Pop())
			{
			fprintf(stderr, "Object: (%4.4x, %4.4x), %d Length\n",
				vr->Group, vr->Element, vr->Length);

			switch(vr->Element)
				{
				case	0x0000:	delete vr; break;
				case	0x0002:	DCOR.Push(vr);	break;
				case	0x0100:
					tuint16 = 0x8030;	// 0x8030
					memcpy(vr->Data, &tuint16, 2);
					DCOR.Push(vr);	break;
				case	0x0800:	DCOR.Push(vr);	break;
				case	0x0110:
					vr->Element = 0x0120;
					DCOR.Push(vr);	break;
				default:
					delete vr;
				}
			}
		vr = new VR(0x0000, 0x0900, 0x0002, TRUE);
		tuint16 = 0;
		memcpy(vr->Data, &tuint16, 2);
		DCOR.Push(vr);
		PDU.Write(&DCOR);
		PDU.Close();
		return ( TRUE );
		}
	// The sender should intiate the close at this point, but send
	// one anyway (wont hurt).
	return ( FALSE );
	}

BOOL
CEchoClient(BYTE	*ip, BYTE	*port)
	{
	PolaroidPDU_Service			PDU;
	DICOMCommandObject	DCO;
	DICOMCommandObject	DCOR;
	UID					uid;
	VR					*vr;
	LE_UINT16				tuint16, command, datasettype, messageid;
	BYTE				SOP[64];

	PDU.ClearAbstractSyntaxs();
	PDU.SetLocalAddress(LOCAL_ACR);
	PDU.SetRemoteAddress(REMOTE_ACR);
	uid.Set("1.2.840.10008.3.1.1.1");
	PDU.SetApplicationContext(uid);
	uid.Set("1.2.840.10008.1.1");
	PDU.AddAbstractSyntax(uid);

	if(!PDU.Connect(ip, port))
		{
		Dump((AAssociateRQ)PDU);
		// Some error.  Print out AAssociateRJ data

		fprintf(stderr, "AAssociateRJ: %d, %d, %d\n",
			PDU.AAssociateRJ :: Result,
			PDU.AAssociateRJ :: Source,
			PDU.AAssociateRJ :: Reason);
		return ( FALSE );
		}
	// Fix the Polaroid connection
	PDU.FixPolaroidConnection();
	Dump((AAssociateRQ)PDU);
	Dump((AAssociateAC)PDU);
	
	strcpy((char*) SOP, "1.2.840.10008.1.1"); 
	vr = new VR (0x0000, 0x0002, strlen((char*)SOP), (void*) SOP, FALSE);
	DCO.Push(vr);
	command = 0x0030;
	vr = new VR (0x0000, 0x0100, 0x0002, &command, FALSE);
	DCO.Push(vr);
	datasettype = 0x0101;	
	vr = new VR (0x0000, 0x0800, 0x0002, &datasettype, FALSE);
	DCO.Push(vr);
	messageid = 1;
	vr = new VR (0x0000, 0x0110, 0x0002, &messageid, FALSE);
	DCO.Push(vr);
	fprintf(stderr, "Writting CEcho-RQ %d\n", PDU.Write(&DCO, uid));
	fprintf(stderr, "Waiting for CEcho-RSP\n");

	if(!PDU.Read(&DCOR))
		return ( FALSE );	// associate lost
	while(vr = DCOR.Pop())
		{
//		fprintf(stderr, "Object: (%4.4x, %4.4x), %d Length\n",
//			vr->Group, vr->Element, vr->Length);
		fprintf(stderr, "%8.8x   ", vr);
		DumpVR ( vr );
		delete vr;
		}
	PDU.Close();
	return ( TRUE );
	}


BOOL
CFindClient(BYTE	*ip, BYTE	*port)
	{
	BOOL				quit;
	PDU_Service			PDU;
	DICOMCommandObject	DCO;
	DICOMCommandObject	DCOR;
	DICOMDataObject		DDO;
	DICOMDataObject		DDOR;
	UID					uid;
	VR					*vr;
	LE_UINT16				tuint16, command, datasettype, messageid, priority;
	BYTE				SOP[64];
	BYTE				QLevel[16];
	BYTE				AppTitle[64];
	BYTE				Star[32];
		
	PDU.ClearAbstractSyntaxs();
	PDU.SetLocalAddress(LOCAL_ACR);
	PDU.SetRemoteAddress(REMOTE_ACR);
	uid.Set("1.2.840.10008.3.1.1.1");	// DICOM App
	PDU.SetApplicationContext(uid);
	uid.Set("1.2.840.10008.5.1.4.1.2.1.1");	// C-Find SOP
	//PDU.AddAbstractSyntax(uid);
	uid.Set("1.2.840.10008.5.1.4.1.2.2.1");
	PDU.AddAbstractSyntax(uid);
	uid.Set("1.2.840.10008.5.1.4.1.2.3.1");
	//PDU.AddAbstractSyntax(uid);



	if(!PDU.Connect(ip, port))
		{
		// Some error.  Print out AAssociateRJ data

		fprintf(stderr, "AAssociateRJ: %d, %d, %d\n",
			PDU.AAssociateRJ :: Result,
			PDU.AAssociateRJ :: Source,
			PDU.AAssociateRJ :: Reason);
		return ( FALSE );
		}
	strcpy((char*) SOP, "1.2.840.10008.5.1.4.1.2.2.1"); 
	vr = new VR (0x0000, 0x0002, strlen((char*)SOP), (void*) SOP, FALSE);
	DCO.Push(vr);
	command = 0x0020;
	vr = new VR (0x0000, 0x0100, 0x0002, &command, FALSE);
	DCO.Push(vr);
	priority = 0;	// MEDIUM
	vr = new VR (0x0000, 0x0700, 0x0002, &priority, FALSE);
	DCO.Push(vr);
	datasettype = 0x0102;	
	vr = new VR (0x0000, 0x0800, 0x0002, &datasettype, FALSE);
	DCO.Push(vr);
	messageid = 3;
	vr = new VR (0x0000, 0x0110, 0x0002, &messageid, FALSE);
	DCO.Push(vr);



	strcpy((char*) QLevel, "STUDY ");
	vr = new VR(0x0008, 0x0052, strlen((char*)QLevel), (void*) QLevel,
			FALSE);
	DDO.Push(vr);
	strcpy((char*) AppTitle, "UCD_MRS1_IC0    ");
	vr = new VR(0x0008, 0x0054, 16, (void*)AppTitle, FALSE);
	DDO.Push(vr);
	
	strcpy((char*) &Star[0], "*");
	vr = new VR(0x0008, 0x0018, 0, (BOOL) FALSE);	DDO.Push(vr);
	vr = new VR(0x0020, 0x0013, 0, (BOOL) FALSE);	DDO.Push(vr);
	vr = new VR(0x0020, 0x000d, 0, (BOOL) FALSE);	DDO.Push(vr);
	vr = new VR(0x0010, 0x0010, 2, (void*)Star, (BOOL) FALSE);	DDO.Push(vr);
	
	PDU.Write(&DCO);
	PDU.Write(&DDO);

	quit = 0;
	while(!quit)
		{
		
//		fprintf(stderr, "Waiting for CFind-RSP");
		if(!PDU.Read(&DCOR))
			return ( FALSE );	// associate lost
		// is this a C-Find-RSP ?
		if(DCOR.GetUINT16(0x0000, 0x0100)!=0x8020)
			{
//			fprintf(stderr, "not a C-Find-RSP: %4.4x\n",
//				DCOR.GetUINT16(0x0000, 0x0100));
			PDU.Close();
			return(FALSE);
			}
		// is there a data set?
		if(DCOR.GetUINT16(0x0000, 0x0800)==0x0101)
			{
//			fprintf(stderr, "no data set included\n");
//			fprintf(stderr, "status: %4.4x\n",
//				DCOR.GetUINT16(0x0000, 0x0900));
//			while(vr = DCOR.Pop())
//				{
//				DumpVR(vr);
//				}
			PDU.Close();
			return( TRUE );
			}
//		fprintf (stderr, "(%4.4x)", DCOR.GetUINT16(0x0000, 0x0900) );
		
		if(DCOR.GetUINT16(0x0000, 0x0900)==0x0000)	// success
			{
			PDU.Close();
			return ( TRUE );
			}
			
//		fprintf(stderr, "Waiting for data section\n");
		if(!PDU.Read(&DDOR))
			{
			PDU.Close();
			return(FALSE);
			}
//		fprintf(stderr, "Command Object:\n");
//		while(vr = DCOR.Pop())
//			{
//			DumpVR(vr);
//			fprintf(stderr, "\tObject: (%4.4x, %4.4x), %d Length\n",
//				vr->Group, vr->Element, vr->Length);
//			}
		// figure out what we got in the data section
//		fprintf(stderr, "Data Object:\n");
		while(vr = DDOR.Pop())
			{
			if(vr->Group == 0x0000)
				{
				fprintf(stderr, "Data Object:\n");
				DumpVR(vr);
				while(vr = DDOR.Pop())
					DumpVR(vr);
				fprintf(stderr, "Command Object:\n");
				while(vr = DCOR.Pop())
					DumpVR(vr);
				PDU.Close();
				return ( TRUE );
				}
			if(vr->Group == 0x0010)
				if(vr->Element == 0x0010)
					DumpVR(vr);
//			fprintf(stderr, "\tObject: (%4.4x, %4.4x), %d Length\n",
//				vr->Group, vr->Element, vr->Length);
			}
		while(vr = DCOR.Pop())
			;
		}

	PDU.Close();
	return ( TRUE );
	}



BOOL
DICOMParseProc(DICOMDataObject	*DDOPtr)
	{
//	fprintf(stderr, "Child running in background\n");


	delete DDOPtr;
#ifdef	WINDOWS	
	ExitThread(1);
#endif
	return (FALSE);	
	}

BOOL
Fork(void	*Data)
	{
#ifdef	WINDOWS	
	DWORD	ThreadID;
	if(!CreateThread(NULL, 0x00008000, (LPTHREAD_START_ROUTINE) DICOMParseProc,
		Data, 0, &ThreadID))
		return ( FALSE );
#else
	DICOMParseProc ( (DICOMDataObject *) Data );
#endif
	return ( TRUE );
	}
		
BOOL
CStoreServer()
	{
	PDU_Service			PDU;
	DICOMCommandObject	DCO;
	DICOMCommandObject	*DCORPtr;
	DICOMDataObject		*DDOPtr;
	VR					*vr;
	LE_UINT16				tuint16;
	LE_UINT16				Command, MId, MRId, DSet, E200, E300, E700,E900;
	
	if(PDU.Listen(PORT))
		{
		while(TRUE)
			{
			if(!PDU.Read(&DCO))
				return ( FALSE );
			if(DCO.GetUINT16(0x0000, 0x0100)!=0x0001)
				return ( FALSE );	// not a CStore
				DDOPtr = new DICOMDataObject;
			if(!DDOPtr)
				return(FALSE);
			
			if(!PDU.Read(DDOPtr))
				return ( FALSE );
			if(ForkAProc)
				if(!Fork((void*) DDOPtr))
					{
					fprintf(stderr, "Unable to create thread\n");
					delete DDOPtr;
					}
			DCORPtr = new DICOMCommandObject;
			if(!DCORPtr)
				return ( FALSE );
		
			Command = 0x8001;
			MId = DCO.GetUINT16(0x0000, 0x0110);
			MRId = MId;
			DSet = 0x0101;
			E200 = DCO.GetUINT16(0x0000, 0x0200);
			E300 = DCO.GetUINT16(0x0000, 0x0300);
			E700 = 0;
			E900 = 0;

			vr = new VR(0x0000, 0x0100, 2, &Command, FALSE);	DCORPtr->Push(vr);
			vr = new VR(0x0000, 0x0110, 2, &MId, FALSE);		DCORPtr->Push(vr);
			vr = new VR(0x0000, 0x0120, 2, &MRId, FALSE);		DCORPtr->Push(vr);
			vr = new VR(0x0000, 0x0200, 2, &E200, FALSE);		DCORPtr->Push(vr);
			vr = new VR(0x0000, 0x0300, 2, &E300, FALSE);		DCORPtr->Push(vr);
			vr = new VR(0x0000, 0x0700, 2, &E700, FALSE);		DCORPtr->Push(vr);
			vr = new VR(0x0000, 0x0800, 2, &DSet, FALSE);		DCORPtr->Push(vr);
			vr = new VR(0x0000, 0x0900, 2, &E900, FALSE);		DCORPtr->Push(vr);
			while(vr = DCO.Pop())
				;
						
			PDU.Write(DCORPtr);
			}
		}
	PDU.Close();
	return ( TRUE );
	}

// Combined C-Echo / C-Store SCP's.  Performs same functions as
// CEchoServer() and CStoreServer().  This routine is ment to be
// run from a "driver" routine which handles the listen / accept socket
// I/O.
	

BOOL
CMEchoStoreServerProc(int	socketfd)
	{
	PDU_Service			PDU;
	DICOMCommandObject	DCO;
	DICOMCommandObject	*DCORPtr;
	DICOMDataObject		*DDOPtr;
	DICOMCommandObject	DCOR;
	VR					*vr;
	LE_UINT16				tuint16;
	LE_UINT16				Command, MId, MRId, DSet, E200, E300, E700,E900;

	// NOTE: PDU.Multiplex(filedes).  This call is saying, here's a just
	// connected socket, now go through the regular PDU association, and
	// return to me a connected DICOM link.
	if(PDU.Multiplex(socketfd))
		{
		while(TRUE)
			{
			if(!PDU.Read(&DCO))
				return ( FALSE );
			switch ( DCO.GetUINT16 ( 0x0000, 0x0100 ) )
				{
				case	0x0030:
					while(vr = DCO.Pop())
						{
					//	fprintf(stderr, "Object: (%4.4x, %4.4x), %d Length\n",
					//		vr->Group, vr->Element, vr->Length);

						switch(vr->Element)
							{
							case	0x0000:	delete vr; break;
							case	0x0002:	DCOR.Push(vr);	break;
							case	0x0100:
								tuint16 = 0x8030;	// 0x8030
								memcpy(vr->Data, &tuint16, 2);
								DCOR.Push(vr);	break;
							case	0x0800:	DCOR.Push(vr);	break;
							case	0x0110:
								vr->Element = 0x0120;
								DCOR.Push(vr);	break;
							default:
								delete vr;
							}
						}
					vr = new VR(0x0000, 0x0900, 0x0002, TRUE);
					tuint16 = 0;
					memcpy(vr->Data, &tuint16, 2);
					DCOR.Push(vr);
					PDU.Write(&DCOR);
					break;
				case	0x0001:		// CStore
					DDOPtr = new DICOMDataObject;
					if(!DDOPtr)
						return(FALSE);
					if(!PDU.Read(DDOPtr))
						return ( FALSE );
					if(ForkAProc)
						if(!Fork((void*) DDOPtr))
							{
//							fprintf(stderr, "Unable to create thread\n");
							delete DDOPtr;
							}
					DCORPtr = new DICOMCommandObject;
					if(!DCORPtr)
						return ( FALSE );
		
					Command = 0x8001;
					MId = DCO.GetUINT16(0x0000, 0x0110);
					MRId = MId;
					DSet = 0x0101;
					E200 = DCO.GetUINT16(0x0000, 0x0200);
					E300 = DCO.GetUINT16(0x0000, 0x0300);
					E700 = 0;
					E900 = 0;

					vr = new VR(0x0000, 0x0100, 2, &Command, FALSE);	DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0110, 2, &MId, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0120, 2, &MRId, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0200, 2, &E200, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0300, 2, &E300, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0700, 2, &E700, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0800, 2, &DSet, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0900, 2, &E900, FALSE);		DCORPtr->Push(vr);
					while(vr = DCO.Pop())
						;
						
					PDU.Write(DCORPtr);
					break;
				}
			}
		}
	PDU.Close();
	return ( TRUE );
	}

// Driver routine for Multiplexed Socket I/O (re-use-address type).  Note,
// in a real server the child should be forked off.
BOOL
CMEchoStoreServer()
	{
	Socket	MSocket;

	if(!MSocket.Listen((char*)PORT))
		return ( FALSE );
	while(MSocket.Accept())
		{
		CMEchoStoreServerProc(MSocket.Socketfd);
		MSocket.Socketfd = 0;
		MSocket.Connected = FALSE;
		}
	return ( FALSE );	// should never return except on error
	}



BOOL
CEchoStoreServer()
	{
	PDU_Service			PDU;
	DICOMCommandObject	DCO;
	DICOMCommandObject	*DCORPtr;
	DICOMDataObject		*DDOPtr;
	DICOMCommandObject	DCOR;
	VR					*vr;
	LE_UINT16				tuint16;
	LE_UINT16				Command, MId, MRId, DSet, E200, E300, E700,E900;

	if(PDU.Listen(PORT))
		{
		while(TRUE)
			{
			if(!PDU.Read(&DCO))
				return ( FALSE );
			switch ( DCO.GetUINT16 ( 0x0000, 0x0100 ) )
				{
				case	0x0030:
					while(vr = DCO.Pop())
						{
					//	fprintf(stderr, "Object: (%4.4x, %4.4x), %d Length\n",
					//		vr->Group, vr->Element, vr->Length);

					//			delete vr;
						switch(vr->Element)
							{
							case	0x0000:	delete vr; break;
							case	0x0002:	DCOR.Push(vr);	break;
							case	0x0100:
								tuint16 = 0x8030;	// 0x8030
								memcpy(vr->Data, &tuint16, 2);
								DCOR.Push(vr);	break;
							case	0x0800:	DCOR.Push(vr);	break;
							case	0x0110:
								vr->Element = 0x0120;
							DCOR.Push(vr);	break;
							}
						}
					vr = new VR(0x0000, 0x0900, 0x0002, TRUE);
					tuint16 = 0;
					memcpy(vr->Data, &tuint16, 2);
					DCOR.Push(vr);
					PDU.Write(&DCOR);
					break;
				case	0x0001:		// CStore
					DDOPtr = new DICOMDataObject;
					if(!DDOPtr)
						return(FALSE);
					if(!PDU.Read(DDOPtr))
						return ( FALSE );
					if(ForkAProc)
						if(!Fork((void*) DDOPtr))
							{
							fprintf(stderr, "Unable to create thread\n");
							delete DDOPtr;
							}
					DCORPtr = new DICOMCommandObject;
					if(!DCORPtr)
						return ( FALSE );
		
					Command = 0x8001;
					MId = DCO.GetUINT16(0x0000, 0x0110);
					MRId = MId;
					DSet = 0x0101;
					E200 = DCO.GetUINT16(0x0000, 0x0200);
					E300 = DCO.GetUINT16(0x0000, 0x0300);
					E700 = 0;
					E900 = 0;

					vr = new VR(0x0000, 0x0100, 2, &Command, FALSE);	DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0110, 2, &MId, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0120, 2, &MRId, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0200, 2, &E200, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0300, 2, &E300, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0700, 2, &E700, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0800, 2, &DSet, FALSE);		DCORPtr->Push(vr);
					vr = new VR(0x0000, 0x0900, 2, &E900, FALSE);		DCORPtr->Push(vr);
					while(vr = DCO.Pop())
						;
						
					PDU.Write(DCORPtr);
					break;
				}
			}
		}
	// The sender should intiate the close at this point, but send
	// one anyway (wont hurt).
	PDU.Close();
	return ( TRUE );
	}
	
BOOL
PrintOptions()
	{
	fprintf(stderr, "usage: dicom [-v filename ] | [-l:local_acr_nema] [-r:remote_acr_nema] [-s<e|s|c>|e|f] [-1]<host &| port>\n");
	return ( TRUE );
	}
#ifdef	MAC
extern	int	SMain(int	, char	**);
main()
	{
	int		argc;
	char	*ch, *nch;
	char	s[256];
	char	str[15][128];
	char	*argv[15];
	
	VRType.AttachRTC("dicom-dict.txt");

	argc = 0;
	while(argc<15)
		{
		argv[argc] = str[argc];
		++argc;
		}
	
	GUSISetup(GUSIwithInternetSockets);

	while(TRUE)
		{
		printf("-> ");
		fgets(s, 256, stdin);
		argc = 1;
		if(!strncmp(s, "quit", 4))
			return(0);
		ch = s;
		while((*ch)==' ')
			++ch;
		while(nch=strchr(ch, ' '))
			{
			(*nch)='\0';
			strcpy(argv[argc], ch);
			++argc;
			ch = nch;
			++ch;
			while((*ch)==' ')
				++ch;
			}
		if(nch=strchr(ch, '\n'))
			{
			(*nch)='\0';
			strcpy(argv[argc], ch);
			++argc;				
			}
		SMain(argc, argv);	
		}
	}
#endif

#ifndef	MAC
main (int	argc, char	*argv[])
#else
int
SMain(int	argc, char	*argv[])
#endif
	{
	int	valid_argc;
	int	Mode;
	int	ContOp;

	valid_argc = 1;
	Mode = CECHO_CLIENT;
	ForkAProc = FALSE;
	ForkProc = NULL;
	ContOp = 2;

#ifndef	MAC
	VRType.AttachRTC("dicom-dict.txt");
	//VRType.AttachRTC("c:\\lib\\dicom-dict.txt");
#endif
//	fprintf(stderr, "LE_UINT16=%d LE_UINT32=%d\n", sizeof(LE_UINT16), sizeof(LE_UINT32));	
	while(valid_argc < argc)
		{
		if((argv[valid_argc][0]=='-')||(argv[valid_argc][0]=='/'))
			{
			switch ( argv[valid_argc][1] )
				{
				case	'l':
				case	'L':
					strcpy((char*) LOCAL_ACR, &argv[valid_argc][3]);
					break;
				case	'r':
				case	'R':
					strcpy((char*) REMOTE_ACR, &argv[valid_argc][3]);
					break;
				case	'd':
				case	'D':
					strcpy((char*) Directory, &argv[valid_argc][3]);
					break;
				case	'P':
				case	'p':
					strcpy((char*) PNAME, &argv[valid_argc][3]);
					break;				
				case	'1':
					ContOp = FALSE;
					break;
				case	'v':
				case	'V':
						Mode = CDUMPFILE;
						break;
				case	'S':
				case	's':
					switch ( argv[valid_argc][2] )
						{
						case	'c':
						case	'C':
							Mode = CECHOSTORE_SERVER;
							if(ContOp==2)
								ContOp = TRUE;
							break;
						case	'E':
						case	'e':						
							Mode = CECHO_SERVER;
							if(ContOp==2)
								ContOp = TRUE;
							break;
						case	'S':
						case	's':
							Mode = CSTORE_SERVER;
							ForkProc = DICOMParseProc;
							ForkAProc = TRUE;
							if(ContOp==2)
								ContOp = TRUE;
							break;
						default:
							fprintf(stderr, "error server option: %c\n", argv[valid_argc][2]);
							PrintOptions();
							return ( 1 );
							
						}
					break;
				case	'F':
				case	'f':
					Mode = CFIND_CLIENT;
					break;
				case	'E':
				case	'e':
					Mode = CECHO_CLIENT;
					break;
				default:
					fprintf(stderr, "unknown option: %c\n",
						argv[valid_argc][1]);
					PrintOptions();
					return(1);
				}
			++valid_argc;
			}
		else
			break;
		}
	if(ContOp==2)
		ContOp = FALSE;
		
	switch ( Mode )
		{
		case	CDUMPFILE:
			while ( valid_argc < argc )
				DumpDDOFile(argv[valid_argc++]);
			return(0);
		case	CFIND_CLIENT:
			switch(argc - valid_argc)
				{
				case	0:
					PrintOptions();
					return(2);
				case	1:
					return(CFindClient((BYTE*) argv[valid_argc], (BYTE*) "104"));
				case	2:
					return(CFindClient((BYTE*) argv[valid_argc], (BYTE*) argv[valid_argc+1]));
				default:
					fprintf(stderr, "garbled command line\n");
					PrintOptions();
					return(3);
				}
			break;
		case	CSTORE_SERVER:
			switch (argc - valid_argc)
				{
				case	1:
					strcpy((char*) PORT, argv[valid_argc]);
				case	0:
					if(ContOp)
						{
						while ( TRUE )
							{
							CStoreServer();
							}
						}
					else
						{
						CStoreServer();
						}
					break;
				}		
			break;
		
		case	CECHOSTORE_SERVER:
			switch (argc - valid_argc)
				{
				case	1:
					strcpy((char*) PORT, argv[valid_argc]);
				case	0:
					if(ContOp)
						{
						CMEchoStoreServer();
						}
					else
						{
						CEchoStoreServer();
						}
					break;
				}		
			break;
		case	CECHO_CLIENT:
			switch(argc - valid_argc)
				{
				case	0:
					PrintOptions();
					return(2);
				case	1:
					return(CEchoClient((BYTE*) argv[valid_argc], (BYTE*) "104"));
				case	2:
					return(CEchoClient((BYTE*) argv[valid_argc], (BYTE*) argv[valid_argc+1]));
				default:
					fprintf(stderr, "garbled command line\n");
					PrintOptions();
					return(3);
				}
			break;
		case	CECHO_SERVER:
			switch(argc - valid_argc)
				{
				case	0:
					if(ContOp)
						while( TRUE )
							if(!CEchoServer())	break;
					else
						return(CEchoServer());
					break;
				case	1:
					strcpy((char*) PORT, argv[valid_argc]);
					if(ContOp)
						while ( TRUE )
							if(!CEchoServer())	break;
					else
						return(CEchoServer());
					break;
				default:
					fprintf(stderr, "garbled command line\n");
					PrintOptions();
				}
			break;
		}
	return(10000);	// should never get here
	}

