/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/

// Q/R SOP Class

// Abstract Base Class for Q/R


//##ModelId=38F5FEF803AE
class	StandardQuery	:
	public	CFindRQ,
	public	CFindRSP
	{
	public:
	//##ModelId=38F5FEF9014D
		virtual	BOOL	GetUID (UID	&uid) { return (uGetUID(uid)); };
	//##ModelId=38F5FEF90125
		virtual	BOOL	uGetUID ( UID &) = 0;
	//##ModelId=38F5FEF900E9
		virtual	BOOL	SearchOn (	DICOMDataObject	*,
									Array < DICOMDataObject  *> 	*) = 0;
	//##ModelId=38F5FEF900B7
		virtual	BOOL	CallBack ( 	DICOMCommandObject	*,
									DICOMDataObject * ) = 0;
	//##ModelId=38F5FEF90085
		BOOL	Read (	PDU_Service	*,
						DICOMCommandObject	*);
	//##ModelId=38F5FEF9005D
		BOOL	Write (	PDU_Service	*,
						DICOMDataObject	*);
						
	};

//##ModelId=38F5FEEB03CE
class	StandardRetrieve	:
	public	CMoveRQ,
	public	CMoveRSP
	{
	public:
	//##ModelId=38F5FEEC01E5
		virtual	BOOL	GetUID (UID	&uid) { return (uGetUID(uid)); };
	//##ModelId=38F5FEEC01B2
		virtual	BOOL	uGetUID ( UID &) = 0;
	//##ModelId=38F5FEEC0158
		virtual	BOOL	SearchOn ( DICOMDataObject	*,
								Array < DICOMDataObject *> *) = 0;
	//##ModelId=38F5FEEC011C
		virtual	BOOL	RetrieveOn (	DICOMDataObject *,
										DICOMDataObject **,
										StandardStorage	**) = 0;
	//##ModelId=38F5FEEC00D6
		virtual	BOOL	QualifyOn ( BYTE *, BYTE *, BYTE *, BYTE * ) = 0;
	//##ModelId=38F5FEEC00AE
		virtual	BOOL	CallBack (	DICOMCommandObject	*,
									DICOMDataObject	* ) = 0;
	//##ModelId=38F5FEEC0086
		BOOL	Read (	PDU_Service *, DICOMCommandObject	* );
	//##ModelId=38F5FEEC005E
		BOOL	Write ( PDU_Service	*, DICOMDataObject	*, BYTE	*);
	};

//##ModelId=38F5FEEB0247
class	PatientRootQuery	:
			public	StandardQuery
	{
	public:
	//##ModelId=38F5FEEB02E7
		BOOL	GetUID ( UID & );
	//##ModelId=38F5FEEB02D3
		BOOL	uGetUID ( UID &uid ) { return ( GetUID(uid) ); };
	//##ModelId=38F5FEEB02BF
		inline	BOOL	Read (	PDU_Service	*PDU,
								DICOMCommandObject	*DCO )
			{ return ( StandardQuery :: Read ( PDU, DCO ) ); };
	//##ModelId=38F5FEEB02AB
		inline	BOOL	Write (	PDU_Service	*PDU,
						DICOMDataObject	*DDO)
			{ return ( StandardQuery :: Write ( PDU, DDO ) ); };
	};

//##ModelId=38F5FEE00101
class	PatientRootRetrieve	:
			public	StandardRetrieve
	{
	public:
	//##ModelId=38F5FEE00197
		BOOL	GetUID ( UID & );
	//##ModelId=38F5FEE00183
		BOOL	uGetUID ( UID &uid ) { return ( GetUID(uid) ); };

	//##ModelId=38F5FEE0016F
		inline	BOOL	Read (	PDU_Service	*PDU,
								DICOMCommandObject	*DCO )
			{ return ( StandardRetrieve :: Read ( PDU, DCO ) ); };
	//##ModelId=38F5FEE00152
		BOOL	Write (	PDU_Service	*PDU,
						DICOMDataObject	*DDO,
						BYTE	*ACRNema)
			{ return ( StandardRetrieve :: Write ( PDU,
						DDO, ACRNema )); };
	};

//##ModelId=38F5FEF00399
class	StudyRootQuery	:
			public	StandardQuery
	{
	public:
	//##ModelId=38F5FEF10051
		BOOL	GetUID ( UID & );
	//##ModelId=38F5FEF1003D
		BOOL	uGetUID ( UID &uid ) { return ( GetUID(uid) ); };
	//##ModelId=38F5FEF10029
		inline	BOOL	Read (	PDU_Service	*PDU,
								DICOMCommandObject	*DCO )
			{ return ( StandardQuery :: Read ( PDU, DCO ) ); };
	//##ModelId=38F5FEF10015
		inline	BOOL	Write (	PDU_Service	*PDU,
						DICOMDataObject	*DDO)
			{ return ( StandardQuery :: Write ( PDU, DDO ) ); };
	};

//##ModelId=38F5FEEC0299
class	StudyRootRetrieve	:
			public	StandardRetrieve
	{
	public:
	//##ModelId=38F5FEEC033A
		BOOL	GetUID ( UID & );
	//##ModelId=38F5FEEC032F
		BOOL	uGetUID ( UID &uid ) { return ( GetUID(uid) ); };
		
	//##ModelId=38F5FEEC0312
		inline	BOOL	Read (	PDU_Service	*PDU,
								DICOMCommandObject	*DCO )
			{ return ( StandardRetrieve :: Read ( PDU, DCO ) ); };
	//##ModelId=38F5FEEC02FD
		BOOL	Write (	PDU_Service	*PDU,
						DICOMDataObject	*DDO,
						BYTE	*ACRNema)
			{ return ( StandardRetrieve :: Write ( PDU,
						DDO, ACRNema )); };
	};

//##ModelId=38F5FF0100FE
class	PatientStudyOnlyQuery	:
			public	StandardQuery
	{
	public:
	//##ModelId=38F5FF0101DB
		BOOL	GetUID ( UID & );
	//##ModelId=38F5FF0101D1
		BOOL	uGetUID ( UID &uid ) { return ( GetUID(uid) ); };
	//##ModelId=38F5FF0101B4
		inline	BOOL	Read (	PDU_Service	*PDU,
								DICOMCommandObject	*DCO )
			{ return ( StandardQuery :: Read ( PDU, DCO ) ); };
	//##ModelId=38F5FF01019F
		inline	BOOL	Write (	PDU_Service	*PDU,
						DICOMDataObject	*DDO)
			{ return ( StandardQuery :: Write ( PDU, DDO ) ); };
	};

//##ModelId=38F5FEEE0292
class	PatientStudyOnlyRetrieve	:
			public	StandardRetrieve
	{
	public:
	//##ModelId=38F5FEEF003A
		BOOL	GetUID ( UID & );
	//##ModelId=38F5FEEF0026
		BOOL	uGetUID ( UID &uid ) { return ( GetUID(uid) ); };
		
	//##ModelId=38F5FEEF0012
		inline	BOOL	Read (	PDU_Service	*PDU,
								DICOMCommandObject	*DCO )
			{ return ( StandardRetrieve :: Read ( PDU, DCO ) ); };
	//##ModelId=38F5FEEE03DC
		BOOL	Write (	PDU_Service	*PDU,
						DICOMDataObject	*DDO,
						BYTE	*ACRNema)
			{ return ( StandardRetrieve :: Write ( PDU,
						DDO, ACRNema )); };
	};

						
