/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/

// Run-Time-Classing of VR's

BOOL	Pack(BYTE, BYTE, UINT16 &);
BOOL	Pack(UINT16, BYTE &, BYTE &);

#	define	MAKEUINT32(xxx, yyy)	((UINT32) (((UINT32) xxx << 16) | yyy))
typedef	struct	_RTCElement
	{
	UINT16	Group;
	UINT16	Element;
	UINT16	TypeCode;
	char	*Description;
	}	RTCElement;
	
	
//##ModelId=38F5FF020331
class	RTC
	{
	public:
	//##ModelId=38F5FF0300B3
		FixedArray < UINT32, RTCElement >		*TypeCodes;
	//##ModelId=38F5FF0203DB
		BOOL		CarryDescriptions;
	public:
	//##ModelId=38F5FF030183
					RTC (BOOL	CD = TRUE, char *filename = NULL);
	//##ModelId=38F5FF030179
					~RTC ();
	//##ModelId=38F5FF03015B
		BOOL		AttachRTC ( char *filename );
	//##ModelId=38F5FF030147
		BOOL		AttachBinaryRTC ( char *filename );
	//##ModelId=38F5FF03013D
		BOOL		DetachRTC ();
	//##ModelId=38F5FF0300D9
		BOOL		RunTimeClass ( DICOMObject * );
	//##ModelId=38F5FF0300ED
		BOOL		RunTimeClass ( VR * );
	//##ModelId=38F5FF030101
		UINT16		RunTimeClass ( UINT16, UINT16, char * =NULL);
	};



