/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/

/*********************************************************************
 *
 * Connection Class
 *
 *
 *********************************************************************/

// The library used to link with the DICOM Lib has a naming conflict with
// socket.  Therefor we simply remap our socket class into MacSocket.
 
#ifdef	MAC
#	define	Socket	MacSocket
#endif

//##ModelId=38F5FEBC009B
class	Socket
	{
	//##ModelId=38F5FEBC01FA
	int					Error;
	unsigned	long	tulong,*tulongptr;
	public:
	//##ModelId=38F5FEBC01DB
		int					Socketfd;
	//##ModelId=38F5FEBC01BD
		int					ListenSocketfd;
	//##ModelId=38F5FEBC01A9
		BOOL				UDP;
	//##ModelId=38F5FEBC018B
		BOOL				Connected;
	//##ModelId=38F5FEBC0177
		BOOL				Listened;
	private:
	//##ModelId=38F5FEBC016F
	struct	sockaddr_in	sa;
	//##ModelId=38F5FEBC015B
	struct	hostent		hes;
	//##ModelId=38F5FEBC014F
	struct	servent		servs;

	//##ModelId=38F5FEBC00C3
		int					TimeOut;					
	public:
	//##ModelId=38F5FEBD0133
		virtual	BOOL	SendBinary(BYTE *, UINT);
	//##ModelId=38F5FEBD00B0
		virtual	INT		ReadBinary(BYTE *, UINT);
	//##ModelId=38F5FEBD0074
		struct	hostent	*Gethostbyname(char	*);
	//##ModelId=38F5FEBD0006
		struct	servent	*Getservbyname(char	*, char *);
	//##ModelId=38F5FEBC03D0
		int		GetLinkError();
	//##ModelId=38F5FEBC03BC
				Socket();
	//##ModelId=38F5FEBC039E
		virtual	~Socket();		
	//##ModelId=38F5FEBC033A
		virtual	BOOL	Open ( char *ip, char *port );
	//##ModelId=38F5FEBC0326
		BOOL	Close ();
	//##ModelId=38F5FEBC0312
		int		GetLastError()	{ return ( Error ); };
	//##ModelId=38F5FEBC02E0
		BOOL	Listen (char *port);
	//##ModelId=38F5FEBC02CC
		BOOL	Accept ();
	//##ModelId=38F5FEBC02A4
		BOOL	SetTimeOut(int);
		
		// UDP Extensions
	//##ModelId=38F5FEBC0272
		BOOL	BindUDPServer(char *port);
	//##ModelId=38F5FEBC0222
		BOOL	BindUDPClient(char *host, char *port);

	};

